<?php
include_once(dirname(__FILE__) . "/../config/settings.php");

function db_init($db_url) {
	$url = parse_url($db_url);
	$url['user'] = urldecode($url['user']);
	$url['pass'] = isset($url['pass']) ? urldecode($url['pass']) : '';
	$url['host'] = urldecode($url['host']);
	$url['path'] = urldecode($url['path']);

  // Allow for non-standard MySQL port.
  if (isset($url['port'])) {
    $url['host'] = $url['host'] .':'. $url['port'];
  }
  // Test connecting to the database.

  $connection = @mysql_connect($url['host'], $url['user'], $url['pass'], TRUE, 2);
	
	if (!$connection || !mysql_select_db(substr($url['path'], 1))) {
		die('Could not connect to database: ' . mysql_error());
	}
	return $connection;
}

function db_query($query) {
	return mysql_query($query);
}

function db_fetch_array($query){
	$res = mysql_query($query) or die('MYSQL Error: <i>' . mysql_error() . '</i>');
	$retval = array();
	if (mysql_num_rows($res)) {
		while ($row = mysql_fetch_assoc($res)) {
			$retval[] = $row;
		}
	}
	return $retval;
}

function db_fetch_result($query ){
	$res = mysql_query($query) or die('MYSQL Error: <i>' . mysql_error() . '</i>');
	if (!$res) {
    die('Could not query:' . mysql_error());
	}
	if (mysql_num_rows($res)) {
		return mysql_result($res, 0);
	}
	return false;
}


function get_facet_types() {
	return db_fetch_array("select * from facet_types");
}

function get_facet_values(){
	return db_fetch_array("select * from facet_values");
}

function get_clean_fids($fids, $ftid) {
	$q = sprintf("select f_id from facet_values where ft_id = %d and f_id in (%s) order by f_id", $ftid, $fids);
	$tmp = db_fetch_array($q);
	$retval = array();
	//check if all is selected
	$f = explode(',', $fids);
	if (in_array(1000, $f)) { //yes, add all
		$retval[] = 1000;
	}
	
	if (!empty($tmp)) {
		foreach($tmp as $value) {
			$retval[] = $value['f_id'];
		}
	}
	$retval = array_unique($retval); //cleanup duplicates
	return $retval;
}

function get_facet_names($fids, $ftid) {
	$tmp = db_fetch_array("select f_id, f_desc from facet_values where f_id in (" . $fids .")");
	$retval = array();
	if (!empty($tmp)) {
		foreach($tmp as $key=>$value) {
			$retval[$value['f_id']] = $value['f_desc'];
		}
	}
	return $retval;
	
	
}

function get_facet_names_stack($fids, $ftid) {
	$tmp = db_fetch_array("select f_id, f_desc from facet_values where f_id in (" . $fids .") and f_id <> 1000 ");	
	$retval = array();
	if (!empty($tmp)) {
		foreach($tmp as $key=>$value) {
			$retval[$value['f_id']] = $value['f_desc'];
		}
	}
	return $retval;
}

function get_facet_names_gauge($legend, $cur_val, $avg_val, $month) {
   $retval = array();
   $retval[0] = $legend . '(' . $cur_val . ')';
   $retval[1] = '5-Yr ' . $month . ' Avg ' . '(' . $avg_val . ')';
   return $retval;
}

function generate_new_end_time($end_time, $range, $sid) {
	global $report_spans, $sid;
	$last_end_time = substr((string)$end_time, 0, 4) . '-' . substr((string)$end_time, 4, 2);
	$new_date = date('Ym', strtotime('-' . (string)($range) . ' month ' . $last_end_time));	
	if ($sid == 1) {
			$new_date = substr((string)$new_date, 0, 4) . substr((string)$new_date, -1);
	}
	return (int)$new_date;
}


function generate_new_end_time_period($end_time, $sid) {
     global $report_spans;
	$data_table = $report_spans[$sid]['table'];
	$retval = db_fetch_result("SELECT MAX(time_period) from $data_table where time_period < " . $end_time); //compute max for prev list
	return $retval;
} 


function generate_time_periods_orig($granularity, $end_time, $sid) {
	$retval = array();
	
	$grain = 12;
	switch($sid) {
		case 0 : 
		    $grain = 12;
		  
	         $year = substr((string)$end_time, 0, 4);
			$other = substr((string)$end_time, 4, 2);
			$retval[] = $end_time;
			for($i = 1; $i < $granularity; $i++) {
				if ($other > 1) {
					$other--;
				} else {
					$year--;
					$other = $grain;
				}
				$retval[] = $year . str_pad($other, 2, '0', STR_PAD_LEFT);				
			
			}		
			$retval = array_reverse($retval);
		

		break;
		case 1 : 
		    $grain = 4; 
	

			$year = substr((string)$end_time, 0, 4);
			$other = substr((string)$end_time, 4, 1);
			$retval[] = $end_time;
			for($i = 1; $i < $granularity; $i++) {
				if ($other > 1) {
					$other--;
				} else {
					$year--;
					$other = $grain;
				}
	
			$retval[] = $year . $other;
		
			}
		
		$retval = array_reverse($retval);
				
		break;
	}	
	return $retval;
}




function generate_time_periods($granularity, $end_time, $sid=0) {
	$retval = array();
	global $report_spans;
	$data_table = $report_spans[$sid]['table'];
	
	$tmp = db_fetch_array("select * from (select distinct(time_period) from $data_table where time_period <= $end_time order by time_period desc limit $granularity) as tp order by time_period asc");
	foreach($tmp as $val) {
		$retval[] = $val['time_period'];
	}
	return $retval;
	
}


function get_true_location_id($loc_id) {
	$retval = db_fetch_result(sprintf("SELECT l_id from `location_values` where l_id = %d UNION " .
																		"SELECT l_id from `location_values` where l_shortname = '%s'", $loc_id, $loc_id));
	return (count($retval) ? $retval : $loc_id);
}


function validate_end_time($end_time) {
	$end_time *= 1; //make sure its a number
	$end_time = substr((string)$end_time, 0, 6); //kill extra values
	if (strlen($end_time) != 6) {
		$end_time = '';
	}
	return $end_time;
}

function get_datasets_mid($col_names, $fids, $ftid, $gty, $loc_id, $loc_type, $end_time, $debug = false, $sid = 0, $mid =0) {
  
    $current_list = get_datasets_sid($col_names, $fids, $ftid, $gty, $loc_id, $loc_type, $end_time, $debug, $sid);
	
	if ($mid == 1) {	
	        
			global $debug;
			if ($gty > 1) 
				$new_end_time = $current_list[count($current_list) - 2]['time_period'];
			else {
				$new_end_time = $current_list[count($current_list) - 1]['time_period'];
				$new_end_time = generate_new_end_time_period($new_end_time, $sid);
			}
		   //print $new_end_time . '<br>';
			
			$prev_period_list = get_datasets_sid($col_names, $fids, $ftid, $gty, $loc_id, $loc_type, $new_end_time, $debug, $sid);
	        $index_offset =  count($current_list) - count($prev_period_list);	
			 
			$final_list = array();
			foreach($current_list as $id=>$val) {
				foreach($val as $idx => $val_val) {
					if ($idx != 'time_period') {										
						if ($index_offset - $id > 0){ 
							$val[$idx] = 0;
						} 
						else {
							 if (empty($prev_period_list[$id - $index_offset][$idx]) || $prev_period_list[$id - $index_offset][$idx] == 0) {
								$val[$idx] = 0;
							 } else {
								$cur = $val[$idx];
								$prev = $prev_period_list[$id - $index_offset][$idx];							  
								$val[$idx] = number_format(100 * ($cur - $prev) / $prev, 2, '.', '');				  
							}
						}
					}
				}
			$final_list[] = $val;		
		}
		return $final_list;
	} 	
	elseif ($mid ==2) {	
	        
			global $debug;
			$r = 1;
				
			foreach($current_list as $id=>$val) {
				$new_end_time = generate_new_end_time($current_list[$id]['time_period'], $r * 12, $sid);	
			}
							
			$prev_period_list = get_datasets_sid($col_names, $fids, $ftid, $gty, $loc_id, $loc_type, $new_end_time, $debug, $sid);
	        $index_offset =  count($current_list) - count($prev_period_list);	
			
			$final_list = array();		
			foreach($current_list as $id=>$val) {
				foreach($val as $idx => $val_val) {			
					if ($idx != 'time_period') {				
						if ($index_offset - $id > 0){ 
							$val[$idx] = 0;
						} 
						else {						
							 if (empty($prev_period_list[$id][$idx]) || $prev_period_list[$id][$idx] == 0) {  
								$val[$idx] = 0;
							 } else {
								$cur = $val[$idx];						  
								$prev = $prev_period_list[$id][$idx];							  
								$val[$idx] = number_format(100 * ($cur - $prev) / $prev, 2, '.', '');			
							}
						}
					}
				}
			$final_list[] = $val;					
		}	
		return $final_list;		  
	} 	
	return $current_list;
}

 
function get_datasets_sid($col_names, $fids, $ftid, $gty, $loc_id, $loc_type, $end_time, $debug = false, $sid = 0) {
	global $report_spans;
	$data_table = $report_spans[$sid]['table'];

	$label = get_facet_names($fids, $ftid);
	if ((strlen($end_time) != 6) && (strlen($end_time) != 5)) {
		$end_time = db_fetch_result("SELECT MAX(time_period) from $data_table");
	}
	if ($gty == 'ytd') { //YTD is invoked
		$granularity = (int)substr((string)$end_time, 4, 2);
		$time_periods = generate_time_periods_orig($granularity, $end_time, $sid);
	}
	else {
		$time_periods = generate_time_periods_orig($gty, $end_time, $sid);
	}
	
	$retval = array();
	if (!empty($time_periods)) {
		$fid_array = explode(',', $fids);
		$col_array = explode(',', $col_names);
		foreach($time_periods as $value) {
			$q = sprintf("select f_id, %s from `$data_table` " .
									 "where f_id in (%s) and loc_type = %d and loc_id = %d and time_period = %d order by f_id", 
									$col_names, $fids, $loc_type, $loc_id, $value);
			if ($debug) {
				print "<!-- SQL:\"$q\" -->\n";
			}
			$result = db_fetch_array($q);
					
			$tmp = array();
			$tmp['time_period'] = $value;
			if (!empty($result)) {
			    $pos = strpos($col_names, 'ratio');
				if (count($col_array) > 1) { //multi metrics
					foreach($col_array as $col) {
						$tmp[$col] = ($result[0][$col] ? (($pos !== false) ? $result[0][$col] * 100 : $result[0][$col]) : 0);
					}
				} 
				else {
					foreach($fid_array as $fid) {
						$val = 0;
						foreach($result as $v) {
							if ($v['f_id'] == $fid) {
								$val = ($v[$col_names] ? $v[$col_names] : 0);
								break;
							}
						}
						$pos = strpos($col_names, 'ratio');		 
						if ($pos !== false) {
							$val *= 100;
						}	
						
						$tmp[$label[$fid]] = $val;
					}
				}
			} else { //load dummy data to generate empty set
				if (count($col_array) > 1) { //multi metrics
					foreach($col_array as $col) {
						$tmp[$col] = 0;
					}
				} 
				else {
					foreach($fid_array as $v) {
						if (count($label[$v])) {
							$tmp[$label[$v]] = 0;
						}
					}
				}
			}
			$retval[] = $tmp;
		}
	}

	return $retval; 
}


//time comparison 
function get_datasets_by_time_comparison($column, $fid, $gty, $range_array, $loc_id, $loc_type, $end_time, $sid =0) {

    global $report_spans;
	$data_table = $report_spans[$sid]['table'];
	
	if ((strlen($end_time) != 6) && (strlen($end_time) != 5)) {
		$end_time = db_fetch_result("SELECT MAX(time_period) from $data_table");
	}
	if ($gty == 'ytd') { //YTD is invoked
		$granularity = (int)substr((string)$end_time, 4, 2);
		$time_periods = generate_time_periods_orig($$granularity, $end_time, $sid);
	}
	else {
		$time_periods = generate_time_periods_orig($gty, $end_time, $sid);
	}
	

	$retval = array();
	foreach($time_periods as $value) {
		$tp = array();
		$tmp = array();
		foreach ($range_array as $range) {
			if ($sid == 0) {
				$tp[] = $value - (100 * $range);
			} else {
			    $tp[] = $value - (10 * $range);
			}
		}
		$tps = implode(',', $tp);
	
		$q = sprintf("select time_period, %s from `$data_table` " . "where f_id = %d and loc_type = %d and loc_id = %d and time_period in (%s) order by time_period", 
						$column, $fid, $loc_type, $loc_id, $tps);
		$result = db_fetch_array($q);
		
		$tmp['time_period'] = $value;
		foreach ($tp as $v) {	
			$has_value = false;
			foreach($result as $r) {
				if ($v == $r['time_period']) {
				    $pos = strpos($column, 'ratio');
					$tmp[substr($v, 0, 4)] = (($pos !== false) ? $r[$column] * 100 : $r[$column]);
					$has_value = true;
					break;
				}
			}
			if (!$has_value) {	//zerofill
				$tmp[substr($v, 0, 4)] = 0;
			}
		}
		$retval[] = $tmp;
	}
	return $retval;
}

function get_datasets_by_location_comparison_mid($column, $fid, $gty, $lc_array, $end_time, $sid=0, $mid) {

    $current_list = get_datasets_by_location_comparison($column, $fid, $gty, $lc_array, $end_time, $sid);
	
	if ($mid == 1) {	
	        
			global $debug;
			if ($gty > 1) 
				$new_end_time = $current_list[count($current_list) - 2]['time_period'];
			else {
				$new_end_time = $current_list[count($current_list) - 1]['time_period'];
				$new_end_time = generate_new_end_time_period($new_end_time, $sid);
			}
			
			$prev_period_list = get_datasets_by_location_comparison($column, $fid, $gty, $lc_array, $new_end_time, $sid);
	        $index_offset =  count($current_list) - count($prev_period_list);
			
			
			$final_list = array();
			foreach($current_list as $id=>$val) {
				foreach($val as $idx => $val_val) {
					if ($idx != 'time_period') {
					
						if ($index_offset - $id > 0){ 
							$val[$idx] = 0;
						} 
						else {
							 if (empty($prev_period_list[$id - $index_offset][$idx]) || $prev_period_list[$id - $index_offset][$idx] == 0) {
							   $val[$idx] = 0;
							 } else {
								$cur = $val[$idx];
								
							 $prev = $prev_period_list[$id][$idx];						  
							 $val[$idx] = number_format(100 * ($cur - $prev) / $prev, 2);								
							}
						}
					}
				}
			$final_list[] = $val;
		}
		return $final_list;
	} 
	elseif ($mid ==2) {	
			global $debug;
			$r = 1;

				foreach($current_list as $id=>$val) {
					$new_end_time = generate_new_end_time($current_list[$id]['time_period'], $r * 12, $sid);					
				}
						
			$prev_period_list = get_datasets_by_location_comparison($column, $fid, $gty, $lc_array, $new_end_time, $sid);
	        $index_offset =  count($current_list) - count($prev_period_list);	
			
		    	
			$final_list = array();		
			foreach($current_list as $id=>$val) {
				foreach($val as $idx => $val_val) {
					if ($idx != 'time_period') {
						if ($index_offset - $id > 0){ 
							$val[$idx] = 0;
						} 
						else {
							 if (empty($prev_period_list[$id][$idx]) || $prev_period_list[$id][$idx] == 0) {  
							   $val[$idx] = 0;
							 } else {
							  $cur = $val[$idx];							  
							  $prev = $prev_period_list[$id][$idx];						  
							  $val[$idx] = number_format(100 * ($cur - $prev) / $prev, 2);						 
							}
						}
					}
				}
			$final_list[] = $val;
		}
		return $final_list;		  
	} 
	return $current_list;

}
	
function get_datasets_by_location_comparison($column, $fid, $gty, $lc_array, $end_time, $sid=0) {

    global $report_spans;
	$data_table = $report_spans[$sid]['table'];
	if ((strlen($end_time) != 6) && (strlen($end_time) != 5)) {
		$end_time = db_fetch_result("SELECT MAX(time_period) from $data_table");
	}
	if ($gty == 'ytd') { //YTD is invoked
		$granularity = (int)substr((string)$end_time, 4, 2);
		$time_periods = generate_time_periods_orig($gty, $end_time, $sid);
	}
	else {
		$time_periods = generate_time_periods_orig($gty, $end_time, $sid);
	}
	
	$lids = '(';
	$loc_sql = '(';
	$max = count($lc_array);
	$c = 0;
	foreach($lc_array as $l) {
		$lids .= $l[1];
		$loc_sql .= '(loc_type = '.$l[0].' and loc_id = '.$l[1].')';
		if ($c < $max - 1) {
			$lids .= ',';
			$loc_sql .= ' or ';
		}
		$c++;
	}
	$lids .= ')';
	$loc_sql .= ')';

	$retval = array();
	foreach($time_periods as $value) {
		$tmp = array();
		$tmp['time_period'] = $value;
		
		$q = sprintf("select %s, loc_type, loc_id from `$data_table` " . "where f_id = %d and time_period = %d and %s", $column, $fid, $value, $loc_sql);
		$result = db_fetch_array($q);

		foreach($lc_array as $lc) {
			$tmp[$lc[1]] = 0;	//assume worst case scenario
			if (!empty($result)) { //access db result if not empty
				foreach($result as $r) {
					if ($r['loc_type'] == $lc[0] && $r['loc_id'] == $lc[1]) { //match?
						if($r[$column] == null) {
						    $tmp[$lc[1]] = 0;
						} else {
						   $tmp[$lc[1]] = $r[$column]; 
						}
						$pos = strpos($column, 'ratio');
						
						//if ($column  'sld_avg_sp_to_olp_ratio') 
						if ($pos !== false) 
							$tmp[$lc[1]] *= 100;
						break;
					}
				}
			}
		}
		$retval[] = $tmp;
		
	}	
	return $retval;
	
} 

function get_location_types($lid) {
	$tmp = db_fetch_array(sprintf("select lt_desc from location_types where lt_id = %d", $lid));
	$retval = '';
	if (!empty($tmp)) {
		$retval = $tmp[0]['lt_desc'];
	}
	return $retval;
}

function get_location_values($lt_id) {
	$tmp = db_fetch_array(sprintf("select * from location_values where lt_id = %d", $lt_id));
	$retval = array();
	if (!empty($tmp)) {
		foreach($tmp as $key=>$value) {
			$retval[$value['l_id']] = $value['l_desc'];
		}
	}
	return $retval;
}

function get_location_value_description($lid) {
	$tmp = db_fetch_array(sprintf("select l_desc from location_values where l_id = %d", $lid));
	$retval = '';
	if (!empty($tmp)) {
		$retval = $tmp[0]['l_desc'];
	}
	return $retval;
}

function get_max_value($col_names, $end_time, $sid) {
    global $report_spans;
	$data_table = $report_spans[$sid]['table'];
	$retval = db_fetch_result(sprintf("SELECT MAX(%s) from $data_table where time_period = %d ", $col_names, $end_time)); //compute max for prev list
	return $retval;
}

function list_max($list) {
  $max_val = $list[0];

  foreach ($list as $id => $value) {
    if ($value > $max_val) {
      $max_val = $value + 0.01;
    }
  }
  return $max_val;
}

function list_min($list) {
  $min_val = $list[0];

  foreach ($list as $id => $value) {
    if ($value < $min_val) {
      $min_val = $value;
    }
  }
  return $min_val;
}
	
function list_average($list) {
	$count = count($list); //total numbers in array
	$total = 0;
    foreach ($list as $value) {
        $total = $total + $value; // total value of array numbers
    }
    $average = ($total/$count); // get average value
    return $average;
}

function get_all_locations() {
	$character_set = "SET CHARACTER SET utf8";
	mysql_query($character_set);

	$locations_query = "SELECT
							lv.l_id AS lid,
							lv.lt_id AS ltid,
							lv.l_desc AS l_desc,
							lt.lt_desc AS lt_desc
						FROM
							location_values lv
						JOIN location_types lt ON lt.lt_id = lv.lt_id
						WHERE lv.l_id != 1000 AND lv.lt_id != 1 ";
	
	$location_result = mysql_query($locations_query);
	return $location_result;
}

function get_pie_chart_data($lid,$ltid){
	$pc_query = "SELECT f_id, f_id2, f_id3, loc_type, loc_id, time_period, SUM(num_parcels) AS num_parcels
	            FROM facet_aggregations_3fd_pdate
	            WHERE loc_type = $ltid 
	            AND loc_id IN ($lid)
	            AND f_id = 1000 
	            AND f_id2 BETWEEN 1200 AND 1210 
	            AND f_id3 = 1000
	            GROUP BY f_id2 ASC;";
    $pc_result = mysql_query($pc_query);
    return $pc_result;
}

function has_pie_chart_data($lid,$ltid){
	if( mysql_num_rows(get_pie_chart_data($lid,$ltid)) == 0 ){
		return false;
	}else{
		return true;
	}
}

function get_latest_time_period(){
	$sql = "SELECT distinct(time_period) as latest_period FROM facet_aggregations order by time_period desc limit 1";
	$result = mysql_query($sql);
	while ($row = mysql_fetch_assoc($result)) {
			$currentYear = preg_replace("/\d{2}$/", "", $row['latest_period']);
			$currentMonth = preg_replace("/^\d{4}/", "", $row['latest_period']);
			break;
	}

	#return $currentMonth." ".$currentYear;
	return date("M", strtotime("{$currentYear}-{$currentMonth}-01"))." ".$currentYear;
}

function get_this_mls_shortname(){
	$lid = 1000;
	$ltid = 1;

	$sql = sprintf("SELECT l_shortname FROM location_values WHERE l_id = %d AND lt_id = %d LIMIT 1",$lid,$ltid);
	$r = mysql_query($sql);

	return mysql_fetch_assoc($r);
}

//initialize database
db_init($db_url);
?>